<template>
    <div class="container">
        
        <div class="collapse" :class="{ show: show }" id="collapseCalendar">
            <div class="card-header bg-white">
                <select-user @select="showProjectsByUser"></select-user>
                <multi-select
                    :options="this.departments"
                    track-by="id"
                    label="name"
                    placeholder="Select Department"
                    @select="showProjectsByDepartment"
                ></multi-select>
            </div>

            <div class="card card-body">
                <b-calendar :projects="dataEvents" :searchBy="dataSearchBy"></b-calendar>
            </div>
        </div>
        <div class="btn-group" role="group" aria-label="Button Group">
            <button
                class="btn btn-primary"
                type="button"
                data-toggle="collapse"
                data-target="#collapseCalendar"
                aria-expanded="false"
                aria-controls="collapseCalendar"
            >
                Calendar
            </button>
            <button
                type="button"
                class="btn btn-secondary"
                v-on:click="clearCalendar"
            >
                Clear
            </button>
        </div>
    </div>
</template>

<script>
import Swal from 'sweetalert2';
import BCalendar from "./CalendarComponent";
import SelectUser from "./SelectUserComponent";
import MultiSelect from "vue-multiselect";

export default {
    components: {
        BCalendar,
        SelectUser,
        MultiSelect
    },
    props: ["value", "show"],
    data() {
        return {
            dataEvents: [],
            dataBackup: [],
            departments: [],
            dataSearchBy: "",
        };
    },
    created() {
        this.prepare();
    },
    methods: {
        getProjects() {
            axios
                .get("/api/project/all")
                .then(res => {
                    if (this.value) {
                        this.dataEvents = _.concat(
                            _.pullAllBy(res.data, [this.value], "id"),
                            this.value
                        );
                    } else {
                        this.dataEvents = res.data;
                    }
                    this.dataBackup = this.dataEvents;
                })
                .catch(err => {
                    console.log(err.message);
                });
        },
        getDepartments() {
            axios
                .get("/api/department/all")
                .then(res => {
                    this.departments = res.data;
                })
                .catch(err => {
                    console.log(err.message);
                });
        },
        prepare() {
            this.getProjects();
            this.getDepartments();
        },
        showProjectsByUser(selectedOption) {
            this.dataSearchBy = selectedOption.full_name;
            axios
                .get("/api/user/" + selectedOption.id + "/projects")
                .then(res => {
                    this.dataEvents = res.data;
                })
                .catch(err => {
                    console.log(err);
                    Swal.fire("Error!", err.message, "error");
                });
        },
        showProjectsByDepartment(selectedOption) {
            this.dataSearchBy = selectedOption.name;
            axios
                .get("/api/department/" + selectedOption.id + "/projects")
                .then(res => {
                    this.dataEvents = res.data;
                })
                .catch(err => {
                    console.log(err);
                    Swal.fire("Error!", err.message, "error");
                });
        },
        clearCalendar() {
            this.dataEvents = this.dataBackup;
            this.dataSearchBy = "";
        }
    }
};
</script>
